
#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

public enum NSL_BarTimeSpanType
{
	Seconds,
	Minutes,
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    [Description("")]
    public class NSL_BarTimeSpan : Indicator
    {
        #region Variables
		private double timelenght;
		#endregion

		#region Initialize
        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
			base.Name = "NSL_BarTimeSpan";
			Add(new Plot(new Pen(Color.Purple, 8), PlotStyle.Bar, "Bar"));
			//Add(new Line(Color.DarkGray, 0, "Zero line"));
			CalculateOnBarClose = true;
			Overlay				= false;
            Add(PeriodType.Tick, 1);
			ZOrder = -1;
		}
		#endregion

		#region OnBarUpdate
        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if(CurrentBars[0] == 0)return;
			
			if(BarsInProgress == 1)
			{
				ChartControl.Refresh();
			}
			
			if(BarsInProgress == 0)
			{
				timelenght = Times[0][1].Subtract(Times[0][0]).TotalDays;
				DateTime myDate = DateTime.FromOADate(timelenght);//Ole Automation Date
				
				switch(timelenghttype)
				{
					case NSL_BarTimeSpanType.Seconds:
						Value.Set(ToTime(myDate));
					break;
						
					case NSL_BarTimeSpanType.Minutes:
						Value.Set(ToTime(myDate)/60);
					break;
				}
				//if (timelenght > timelenghtamount || timelenght < -timelenghtamount)
					//PlotColors[0][0] = Color.Red;
				//else
					//PlotColors[0][0] = Color.Green;
			}
		}
		#endregion
		
        #region Properties
		private NSL_BarTimeSpanType timelenghttype = NSL_BarTimeSpanType.Seconds;
		[GridCategory("Parameters")]
		[Gui.Design.DisplayNameAttribute("\t\tNSL_BarTimeSpan")]
		[RefreshProperties(RefreshProperties.All)]
		public NSL_BarTimeSpanType Timelenghttype
		{
			get { return timelenghttype; }
			set { timelenghttype = value; }
		}
		#endregion
	}
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private NSL_BarTimeSpan[] cacheNSL_BarTimeSpan = null;

        private static NSL_BarTimeSpan checkNSL_BarTimeSpan = new NSL_BarTimeSpan();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NSL_BarTimeSpan NSL_BarTimeSpan(NSL_BarTimeSpanType timelenghttype)
        {
            return NSL_BarTimeSpan(Input, timelenghttype);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NSL_BarTimeSpan NSL_BarTimeSpan(Data.IDataSeries input, NSL_BarTimeSpanType timelenghttype)
        {
            if (cacheNSL_BarTimeSpan != null)
                for (int idx = 0; idx < cacheNSL_BarTimeSpan.Length; idx++)
                    if (cacheNSL_BarTimeSpan[idx].Timelenghttype == timelenghttype && cacheNSL_BarTimeSpan[idx].EqualsInput(input))
                        return cacheNSL_BarTimeSpan[idx];

            lock (checkNSL_BarTimeSpan)
            {
                checkNSL_BarTimeSpan.Timelenghttype = timelenghttype;
                timelenghttype = checkNSL_BarTimeSpan.Timelenghttype;

                if (cacheNSL_BarTimeSpan != null)
                    for (int idx = 0; idx < cacheNSL_BarTimeSpan.Length; idx++)
                        if (cacheNSL_BarTimeSpan[idx].Timelenghttype == timelenghttype && cacheNSL_BarTimeSpan[idx].EqualsInput(input))
                            return cacheNSL_BarTimeSpan[idx];

                NSL_BarTimeSpan indicator = new NSL_BarTimeSpan();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Timelenghttype = timelenghttype;
                Indicators.Add(indicator);
                indicator.SetUp();

                NSL_BarTimeSpan[] tmp = new NSL_BarTimeSpan[cacheNSL_BarTimeSpan == null ? 1 : cacheNSL_BarTimeSpan.Length + 1];
                if (cacheNSL_BarTimeSpan != null)
                    cacheNSL_BarTimeSpan.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNSL_BarTimeSpan = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NSL_BarTimeSpan NSL_BarTimeSpan(NSL_BarTimeSpanType timelenghttype)
        {
            return _indicator.NSL_BarTimeSpan(Input, timelenghttype);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NSL_BarTimeSpan NSL_BarTimeSpan(Data.IDataSeries input, NSL_BarTimeSpanType timelenghttype)
        {
            return _indicator.NSL_BarTimeSpan(input, timelenghttype);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NSL_BarTimeSpan NSL_BarTimeSpan(NSL_BarTimeSpanType timelenghttype)
        {
            return _indicator.NSL_BarTimeSpan(Input, timelenghttype);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NSL_BarTimeSpan NSL_BarTimeSpan(Data.IDataSeries input, NSL_BarTimeSpanType timelenghttype)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NSL_BarTimeSpan(input, timelenghttype);
        }
    }
}
#endregion
